#include <sys/socket.h>
#include <sys/un.h>
#include <poll.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <fcntl.h>
#include <stdio.h>
#include "tbwheel.h"

int main(int argc,char *argv[])
{
	int s;
	int len;
	struct sockaddr_un a;
	char msg[129];

	if(argc<2)
	{
		fprintf(stderr,"usage: %s <command> [<data>]\n",argv[0]);
		return 1;
	}

	len=1;

	if(!strcmp(argv[1],"status"))*msg=CMD_STATUS;
	else if(!strcmp(argv[1],"enable"))*msg=CMD_ENABLE;
	else if(!strcmp(argv[1],"disable"))*msg=CMD_DISABLE;
	else if(!strcmp(argv[1],"scan"))*msg=CMD_ENABLE;
	else if(!strcmp(argv[1],"alt"))*msg=CMD_USEALT;
	else if(!strcmp(argv[1],"shift"))*msg=CMD_USESHIFT;
	else if(!strcmp(argv[1],"device"))
	{
		if(argc!=3)
		{
			fprintf(stderr,"no device specified\n");
			return 1;
		}

		len=strlen(argv[2]);

		if(len>127)
		{
			fprintf(stderr,"device string too long\n");
			return 1;
		}

		msg[0]=CMD_DEVICE;
		msg[1]=len&0xff;
		memcpy(msg+2,argv[2],len);
		len+=2;
	}
	else
	{
		fprintf(stderr,"no such command\n");
		return 1;
	}
	
	if((s=socket(PF_UNIX,SOCK_STREAM,0))==-1)
	{
		perror("socket");
		return 1;
	}

	memset(&a,0,sizeof(a));
	a.sun_family=AF_UNIX;
	strcpy(a.sun_path,CONTROL);

	if(connect(s,(struct sockaddr *)(&a),sizeof(a)))
	{
		perror("connect");
		return 1;
	}

	if(write(s,msg,len)!=len)
	{
		perror("write");
		return 1;
	}

	if(read(s,msg+1,1)!=1)
	{
		perror("read");
		return 1;
	}

	close(s);

	switch(*msg)
	{
	case CMD_STATUS:
		if(!msg[1])printf("inactive\n");
		else printf("active\n");
		break;

	case CMD_ENABLE:
	case CMD_DISABLE:
	case CMD_DEVICE:
	case CMD_USEALT:
	case CMD_USESHIFT:
		if(!msg[1])
		{
			printf("failed\n");
			return 1;
		}
	}

	return 0;
}
